package dk.nsp.idsas.test.stepdefinitions;

import dk.nsp.idsas.test.idptest.SOAPOperation;
import dk.nsp.idsas.test.idptest.ServiceCaller;
import dk.nsp.test.idp.EmployeeIdentities;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.CreateBlurringRequestType;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.PatientIdType;
import io.cucumber.java.en.When;
import org.springframework.beans.factory.annotation.Value;

import javax.xml.bind.JAXBException;
import java.net.URI;
import java.net.URISyntaxException;

import static org.junit.Assert.assertEquals;

public class BlurringStepDefinitions {

    @Value("${idsas.service.endpoint}" + "/20230601/service")
    private String url;

    private final ServiceCaller serviceCaller = new ServiceCaller();

    @When("Sløring oprettes")
    public void createBlurring() throws JAXBException, URISyntaxException {
        CreateBlurringRequestType request = new CreateBlurringRequestType();
        PatientIdType patientId = new PatientIdType();
        patientId.setId("test");
        request.setPatientId(patientId);
        String response = serviceCaller.callRoot(EmployeeIdentities.lægeCharlesBabbage(),
                request, SOAPOperation.CreateBlurring, new URI(url),
                CreateBlurringRequestType.class,
                String.class);
        assertEquals("OK", response);
    }

}