package dk.nsp.idsas.setup;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.jdbc.datasource.embedded.EmbeddedDatabaseBuilder;
import org.springframework.jdbc.datasource.embedded.EmbeddedDatabaseType;

import javax.sql.DataSource;
import java.io.File;
import java.net.URISyntaxException;
import java.util.Arrays;

@Configuration
public class DataSourceTestConfiguration {
    @Bean
    public DataSource getDataSource() throws URISyntaxException {
        String[] sqlFiles = new File(this.getClass().getResource("/").toURI())
                .list((dir, name) -> name.endsWith(".sql"));
        sqlFiles = sqlFiles == null ? new String[0] : sqlFiles;
        Arrays.sort(sqlFiles);
        return new EmbeddedDatabaseBuilder()
                .setType(EmbeddedDatabaseType.H2)
                .setName("IDSAS;MODE=MySQL")
                .addScripts(sqlFiles)
                .build();
    }
}
