package dk.nsp.idsas.util;

import dk.nsp.idsas.dao.AlivenessDao;
import org.apache.commons.httpclient.HttpStatus;

public class DBHealthIndicator implements HealthIndicator {
    private final AlivenessDao alivenessDao;

    public DBHealthIndicator(AlivenessDao alivenessDao) {
        this.alivenessDao = alivenessDao;
    }

    @Override
    public HealthIndication getHealthInfo() {
        return alivenessDao.isAlive() ? new HealthIndication(HttpStatus.SC_OK, "Database: OK")
                : new HealthIndication(HttpStatus.SC_SERVICE_UNAVAILABLE, "Database: Unavailable");
    }
}
